package cn.estsh.i3plus.core.apiservice.serviceimpl.busi;

import cn.estsh.i3plus.core.api.iservice.busi.ICoreMemTreeService;
import cn.estsh.i3plus.platform.common.util.CommonConstWords;
import cn.estsh.i3plus.pojo.base.enumutil.CommonEnumUtil;
import cn.estsh.i3plus.pojo.platform.bean.SysPosition;
import cn.estsh.i3plus.pojo.platform.bean.SysRefUserPosition;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * @Description :
 * @Reference :
 * @Author : wei.peng
 * @CreateDate : 2019-07-04 下午12:46
 * @Modify:
 **/
@Service
public class CoreMemTreeService implements ICoreMemTreeService {

    @Override
    public List<SysPosition> packTreeSysPosition(List<SysPosition> list, Long parentId) {
        List<SysPosition> result = new ArrayList<>();
        List<SysPosition> copyList = new ArrayList<>(list);

        if(list != null && list.size() > 0){
            list.forEach(position -> {
                if(position.getParentId() != null && position.getParentId().equals(parentId)){
                    result.add(position);
                    copyList.remove(position);
                    position.setChildList(packTreeSysPosition(copyList, position.getId()));
                }
            });
        }

        return result;
    }

    @Override
    public List<SysPosition> packTreeSysPositionBySysRefUserPosition(List<SysPosition> list, List<SysRefUserPosition> refList) {
        List<Long> ids = new ArrayList<>(refList.size());

        if(refList != null && refList.size() > 0){
            refList.forEach(ref ->{
                ids.add(ref.getPositionId());
            });
        }

        return packTreeSysPositionByIds(list, ids);
    }

    @Override
    public List<SysPosition> packTreeSysPositionByIds(List<SysPosition> list, List<Long> ids) {
        List<SysPosition> result = new ArrayList<>();

        if(list != null && list.size() > 0){
            list.forEach(position -> {
                if(position.getChildList() == null || position.getChildList().size() <= 0){
                    if(ids.contains(position.getId())){
                        result.add(position);
                    }
                }else{
                    List<SysPosition> childList = packTreeSysPositionByIds(position.getChildList(), ids);
                    if(ids.contains(position.getId()) || childList != null && childList.size() > 0){
                        position.setChildList(childList);
                        result.add(position);
                    }
                }
            });
        }

        return result;
    }

    @Override
    public SysPosition packTreeSysPositionById(List<SysPosition> list, Long id) {
        if(list != null && list.size() > 0){
            for (SysPosition position : list) {
                if(position.getId().equals(id)){
                    position.setChildList(packTreeSysPosition(list, position.getId()));
                    return position;
                }
            }
        }
        return null;
    }

    @Override
    public List<Long> findChildSysPosition(SysPosition position) {
        List<Long> result = new ArrayList<>();

        if(position != null && position.getChildList() != null && position.getChildList().size() > 0){
            for (SysPosition sp : position.getChildList()) {
                result.add(sp.getId());
                result.addAll(findChildSysPosition(sp));
            }
        }

        return result;
    }
}
